package com.avaya.example;

import java.net.URL;

import org.apache.axis.EngineConfiguration;
import org.apache.axis.client.Stub;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import com.avaya.vp.services.AppIntfWS_PortType;
import com.avaya.vp.services.AppIntfWS_ServiceLocator;
import com.avaya.vp.services.LaunchVXMLRequest;
import com.avaya.vp.services.LaunchVXMLResponse;

public class Launch {

    public Launch() {
    }

    public void execute() {
        try {
            Proxy.setupProxy();

            MyEngineConfigurationFactory configFactory = new MyEngineConfigurationFactory(
                    MyEngineConfigurationFactory.AUTHENTICATION_TYPE.DIGEST);
            EngineConfiguration config = configFactory.getClientEngineConfig();

            /* locate the service */
            AppIntfWS_ServiceLocator locator = new AppIntfWS_ServiceLocator(config);
            
            //TODO  Insert your VPMS host name.  Also you must change the
            //TODO  build.xml file that generates the stubs.
            AppIntfWS_PortType appintfws = locator.getAppIntfWS(new URL("http://" + "148.147.46.205" + "/axis/services/AppIntfWS"));

            /* set parameters */
            org.apache.axis.client.Stub stub = (Stub) appintfws;
            stub.setTimeout(45000);// in milliseconds
            stub.setUsername("outcall");
            stub.setPassword("password1");

            /* we are ready to roll */
            System.out.println("Launch Starting");
            LaunchVXMLRequest request = new LaunchVXMLRequest();
            request.setApplicationName("Ross");
            request.setApplicationURL("");
            request.setFromURI("2222222");
            request.setParameters("xxx=dog;yyy=fred");
            request.setToURI("tel:+95777734");
            request.setUuiInfo("");
            request.setConnectTimeoutSecs(45);

            LaunchVXMLResponse response = appintfws.launchVXML(request);
            System.out.println("Launch Result");
            System.out.println("    Session Id : " + response.getSessionID_returned());
            System.out.println("    Total      : " + response.getTotalRes_returned());
            System.out.println("    H323       : " + response.getUnusedH323_returned());
            System.out.println("    SIP        : " + response.getUnusedSIP_returned());

        } catch (Exception e) {
            System.out.println("Launch Failed");
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        /* so axis does not complain about logger not being configured */
        BasicConfigurator.configure();
        Logger.getRootLogger().setLevel(Level.ERROR);

        Launch q = new Launch();
        q.execute();

    }

}