package com.avaya.example;

import java.util.Properties;
import java.util.StringTokenizer;

public class Proxy {

    /**
     * Set the proxies if needed.
     */
    public static void setupProxy() {
        Properties props = System.getProperties();

        setupProxy(props, true, "co.proxy.avaya.com", "8000", "localhost", "http");
        setupProxy(props, true, "co.proxy.avaya.com", "8000", "localhost", "https");

        System.setProperties(props);
    }

    private static void setupProxy(Properties props, boolean useProxy, String proxyHost, String proxyPort, String ignoreHosts,
            String protocol) {

        if (useProxy == true && proxyHost != null && proxyPort != null && ignoreHosts != null) {
            ignoreHosts = ignoreHosts.replace(';', ' ');
            ignoreHosts = ignoreHosts.replace(',', ' ');
            StringTokenizer str = new StringTokenizer(ignoreHosts, " ");
            String ignoreHostsStr = null;
            while (str.hasMoreTokens() == true) {
                if (ignoreHostsStr == null) {
                    ignoreHostsStr = str.nextToken();
                } else {
                    ignoreHostsStr = ignoreHostsStr + "|" + str.nextToken();
                }
            }

            if (useProxy == true) {
                if (ignoreHosts.equals("") == false) {
                    props.put(protocol + ".nonProxyHosts", ignoreHostsStr);
                }
                props.put(protocol + ".proxyHost", proxyHost);
                props.put(protocol + ".proxyPort", proxyPort);
            } else {
                props.remove(protocol + ".proxyHost");
                props.remove(protocol + ".proxyPort");
            }
        }
    }

}